#include "Ball.h"
#include<math.h>
#include<time.h>
#include<SDL.h>
#include<iostream>


CBall::CBall()
{
	

	//Sprite initialisieren
	Ball = new CSprite();
	Ball->Load("Data/Original/Game/Ball.bmp", "Data/Skaliert/Game/Ball.bmp");
	Ball->SetColorKey(255,0,255);
	Ball->SetPos(Pos.x, Pos.y);

	velocity = 400;

	Timer = new CTimer();

	Reset();

	//Timer erzeugen
	
}	

CBall::~CBall()
{
	delete Ball;
	delete Timer;
}

void CBall::Reset()
{
	velocity = 400;

	lastpoint = SDL_GetTicks();
	
	//Position festlegen
	Pos.setCoordinates(953, 533);

	int tempx , tempy;
	//Startwinkel festlegen
	do{
	angle;						//startwinkel

	srand(time(NULL) + SDL_GetTicks());			//random
	angle = (rand()%40);		//winkel berechnen zw -30 & 30

	
	//Geschindigkeit errechnen
	Vel.x = (cos(angle) * velocity);	//x- und y-geschwindigkeitskomponenten errechnen 
	Vel.y = (sin(angle) * velocity);	//
	
	
	tempx= Vel.x;	tempy=Vel.y;

	if(tempx<0)		tempx*=-1;
	if(tempy<0)		tempy*=-1;


	}while(tempx * 1.73 < tempy);

	float temp = ((rand()%20 - 10)>0) ? 1 : -1;			// x-Richtung festlegen
	Vel.x *= temp;

	temp = ((rand()%20 - 10)>0) ? 1 : -1;			// y-Richtung festlegen
	Vel.y *= temp;

	if(Vel.x < 0.1 && Vel.x > -0.1 ){																																																												
		SDL_Delay(20000);																																	
	}
	
}


int CBall::Update(float yPaddel1, float yPaddel2, int phase1, int phase2)
{	
		
	int point = 0;

	if(isAlive == true){

		Timer->Update();
	

		//Wenn seit 15 Sec kein Punkt, Geschwindigkeit um 100 erhhen
		current = SDL_GetTicks();
		if((current - lastpoint)/1000 >= 15.0f)
		{
			lastpoint = current;
			velocity+=100;


			Vel += 100;  // geschwindigkeits-Vektor anpassen

		}


		//Positionen aktualisieren
		Pos.x +=  (Vel.x * (Timer->GetElapsed() / 1000));																		
		Pos.y += (Vel.y * (Timer->GetElapsed() / 1000));
	
		//Kollisionserkennung
		if(Pos.y >= 1065 && Vel.y > 0)			//prfen of unterer Rand erreicht ist
		{
			Vel.y = -Vel.y;							//wenn ja, richtung ndern
		}

		if(Pos.y <= 0 && Vel.y <0)			//prfen of oberer Rand erreicht ist
		{
			Vel.y = -Vel.y;							//wenn ja, richtung ndern
		}
		


		//Kollision rechts
		if(Vel.x > 0)
		{
			if(Pos.x >= 1825 && Pos.x <=1840 && (Pos.y >= (yPaddel2 + 33) && Pos.y <= (yPaddel2 + 147)))	// Ball berhrt Paddel rechts																
			{
				Vel.x = -Vel.x;		// X-Geschwindigkeit umdrehen			
			
				// Winkel des Balls verndern
				if(Vel.y < 0)
				{
					if(phase2 == 0)
						ChangeAngle(-10);
					else if(phase2 == 2)
						ChangeAngle(10);
				}
				else if(Vel.y > 0)
				{
					if(phase2 == 0)
						ChangeAngle(10);
					else if(phase2 == 2)
						ChangeAngle(-10);
				}	

			}
			else if(Pos.x >= 1905)
			{
				Reset();

				point = 1;			//Spieler 1 bekommt punkt
			}
		}


		//Kollision links
		if(Vel.x < 0)
		{
			if((Pos.x <= 80 && Pos.x >=65 && (Pos.y >= (yPaddel1 + 33) && Pos.y <= (yPaddel1 + 147))))		// Ball berhrt Paddel rechts
			{

				Vel.x = -Vel.x;		

				// Winkel des Balls verndern
				if(Vel.y < 0)
				{
					if(phase1 == 0)
						ChangeAngle(10);
					else if(phase1 == 2)
						ChangeAngle(-10);
				}
				else if(Vel.y > 0)
				{
					if(phase1 == 0)
						ChangeAngle(-10);
					else if(phase1 == 2)
						ChangeAngle(10);
				}


			}
			else if(Pos.x <= 0)
			{
				Reset();
				point = 2;			//Spieler 2 bekommt Punkt
			}
		}
	}

	return point;
}

void CBall::Render(SDL_Surface * screen)
{
	Ball->SetPos(Pos.x, Pos.y);
	Ball->Render(screen);
}



//Winkel vergrern/verkleinern
void CBall::ChangeAngle(float newAngle)
{
	float tempX = Vel.x;
	float tempY = Vel.y;


		if(newAngle > 0) 
		{
			if(abs(Vel.x) * 2.5 > abs(Vel.y) || Vel.y < 0.1 && Vel.y > -0.1)
			{
				if(Vel.y >=0)
				{
					Vel.y += 100;
				}
				else
				{
					Vel.y -= 100;
				}
				float alpha = asin( abs(Vel.y) / (float) velocity);
			
				if(Vel.x > 0)
				{
					if(cos(alpha) * velocity >= 0.1 || cos(alpha) * velocity <= -0.1)
					Vel.x = cos(alpha) * velocity;
				}
				else
				{
					if(-cos(alpha) * velocity >= 0.1 || -cos(alpha) * velocity <= -0.1)
					Vel.x = -cos(alpha) * velocity;
				}
			}
		}
		else if (newAngle < 0)
		{
				if(Vel.y >0)
				{
					Vel.y -= 100;
				}
				else
				{
					Vel.y += 100;
				}
				float alpha = asin( abs(Vel.y) / (float) velocity);
			
				if(Vel.x > 0)
				{
					if(cos(alpha) * velocity >= 0.1 || cos(alpha) * velocity <= -0.1)
					Vel.x = cos(alpha) * velocity;
				}
				else
				{
					if(-cos(alpha) * velocity >= 0.1 || -cos(alpha) * velocity <= -0.1)
					Vel.x = -cos(alpha) * velocity;
				}
		}																											


}

void CBall::SetVel(int Vel)
{
	if(velocity < Vel)
	velocity = Vel;
}