#include "Display.h"
#include "Gamestate.h"
#include <SDL_ttf.h>
#include<SDL.h>


CDisplay::CDisplay(void)
{
	SaveLoad = new CSaveLoad;
	fullscreen = SaveLoad->LoadFullscreen();
	
	TTF_Init();
	
	if(fullscreen)
	{
		font = TTF_OpenFont("Data/DejaVuSansMono.ttf",60);

		textColor.r = 13, textColor.g = 16,textColor.b = 121;

		score1Pos.x = 450;
		score1Pos.y = 20;

		score2Pos.x = 1412;
		score2Pos.y = 20;
	}
	else
	{
		font = TTF_OpenFont("Data/DejaVuSansMono.ttf",40);

		textColor.r = 13, textColor.g = 16,textColor.b = 121;

		score1Pos.x = 300;
		score1Pos.y = 13;

		score2Pos.x = 941;
		score2Pos.y = 13;
	}

	winner = new CSprite;
	winner->SetPos(0,0);
}


CDisplay::~CDisplay(void)
{
	delete font;
	TTF_Quit();
}

void CDisplay::Render(SDL_Surface * screen, int Score1, int Score2)
{
	char temp[3];

	//Scores rendern
	sprintf(temp, "%d", Score1);
	score1 = TTF_RenderText_Blended (font, temp , textColor);

	sprintf(temp, "%d", Score2);
	score2 = TTF_RenderText_Blended (font, temp , textColor);

	SDL_BlitSurface(score1, 0, screen, &score1Pos); 
	SDL_BlitSurface(score2, 0, screen, &score2Pos); 


	// Falls ntig, passenden Gewinner/ Verlierer Screen rendern
	if(Score1 == 10 && Gamestate->stateID == STATE_GAME_M)
	{
		winner->Load("Data/Original/Game/Won1.bmp", "Data/Skaliert/Game/Won1.bmp");
		winner->SetColorKey(255, 0, 255);
		winner->Render(screen);
	}

	if(Score1 == 10 && Gamestate->stateID == STATE_GAME_S)
	{
		winner->Load("Data/Original/Game/Won.bmp", "Data/Skaliert/Game/Won.bmp");
		winner->SetColorKey(255, 0, 255);
		winner->Render(screen);
	}

	if(Score2 == 10 && Gamestate->stateID == STATE_GAME_M)
	{
		winner->Load("Data/Original/Game/Won2.bmp", "Data/Skaliert/Game/Won2.bmp");
		winner->SetColorKey(255, 0, 255);
		winner->Render(screen);
	}

	if(Score2 == 10 && Gamestate->stateID == STATE_GAME_S)
	{
		winner->Load("Data/Original/Game/Lost.bmp", "Data/Skaliert/Game/Lost.bmp");
		winner->SetColorKey(255, 0, 255);
		winner->Render(screen);
	}
}

