#include "Game.h"
#include "Gamestate.h"


CGame::CGame(string modus)
{
	
	Ball = new CBall;
	Ball->Start();


	if(modus == "Multi")//Wenn Multiplayergame, usergesteuerte Paddel
	{
		Paddel1=new CPaddel(1, "Multi", Ball);
		Paddel2=new CPaddel(2, "Multi", Ball);
	}

	else						//sonst Paddel mit KI erzeugen
	{
		Paddel1=new CPaddel(1, "Single", Ball);
		Paddel2=new CPaddel(2, "Single", Ball);	
	}
	
	

	Background=new CSprite;
	Background->Load("Data/Original/Game/Background.bmp","Data/Skaliert/Game/Background.bmp");
	Background->SetPos(0 , 0);

	Display = new CDisplay;
	
	score1 = 0;
	score2 = 0;
	won = false;
}

CGame::~CGame()
{
	delete Paddel1;
	Paddel1 = NULL;
	delete Paddel2;
	Paddel2 = NULL;
	delete Ball;
	Ball= NULL;
	delete Background;
	Background = NULL;


}

void CGame::Init()
{
	score1 = 0;
	score2 = 0;
	won = false;
	Ball->Start();
}

void CGame::handle_events()
{
	SDL_Event event;
    while(SDL_PollEvent(&event))
    {
        switch(event.type)
        {
        case SDL_QUIT:
			{
			CGamestate::set_next_state(STATE_EXIT);
            break;
			}
		case SDL_KEYDOWN:
			{
				if(event.key.keysym.sym == SDLK_ESCAPE)
				{
					CGamestate::set_next_state(STATE_MENU);
				}
				if(event.key.keysym.sym == SDLK_RETURN)
				{
					if(won)
						Init();
				}
			}
        }
    }

}


void CGame::logic()
{
	Paddel1->Update(Ball);
	Paddel2->Update(Ball);

	int temp = Ball->Update(Paddel1->GetY(), Paddel2->GetY(),
				Paddel1->GetPhase(), Paddel2->GetPhase());
	switch(temp)
	{
		case 1: score1 ++;
				break;
		case 2: score2 ++;
				break;
		default: break;
	}

	//Geschwindigkeit des Balls anpassen
	if((score1 + score2) >= 3)
	{
		
		Ball->SetVel(450);
	}

	if((score1 + score2) >= 6)
	{
		Ball->SetVel(500);
	}

	if((score1 + score2) >= 9)
	{
		Ball->SetVel(550);
	}

	// Ball stoppen falls 10 Punkte erreicht
	if(score1 == 10 || score2 == 10)
	{
		Ball->Stop();
		won = true;
	}
	
}

void CGame::render(SDL_Surface * screen)
{
		Background->Render(screen);
		Paddel1->Render(screen);
		Paddel2->Render(screen);
		Ball->Render(screen);
		Display->Render(screen, score1, score2);
}




