#include "Options.h"

COptions::COptions(void)
{
	Background = new CSprite;
	Background->Load("Data/Original/Menu/OptionsBack.bmp", "Data/Skaliert/Menu/OptionsBack.bmp");

	Difficulty = new CSprite;
	Difficulty->Load("Data/Original/Menu/Options_Selections1.bmp", "Data/Skaliert/Menu/Options_Selections1.bmp" ,3,221,61);
	Difficulty->SetColorKey(255,0,255);
	Difficulty->SetPos(1080,450);

	Fullscreen = new CSprite;
	Fullscreen->Load("Data/Original/Menu/Options_Selections2.bmp", "Data/Skaliert/Menu/Options_Selections2.bmp",2,100,45);
	Fullscreen->SetColorKey(255,0,255);
	Fullscreen->SetPos(1149,616);

	Select1 = new CSprite;
	Select1->Load("Data/Original/Menu/Options_Select1.bmp", "Data/Skaliert/Menu/Options_Select1.bmp");
	Select1->SetColorKey(255,0,255);
	Select1->SetPos(1049,455);

	Select2 = new CSprite;
	Select2->Load("Data/Original/Menu/Options_Select2.bmp", "Data/Skaliert/Menu/Options_Select2.bmp");
	Select2->SetColorKey(255,0,255);
	Select2->SetPos(1130,622);

	curSelect = 1;
	
	SaveLoad = new CSaveLoad;

	difficulty = SaveLoad->LoadDifficulty();
	fullscreen = SaveLoad->LoadFullscreen() == true ? 1 : 2;
}


COptions::~COptions(void)
{
	delete Background;
	Background = NULL;
	 
	delete Difficulty;
	Difficulty = NULL;

	delete Fullscreen;
	Fullscreen = NULL;

	delete Select1;
	Select1 = NULL;

	delete Select2;
	Select2 = NULL;
}


void COptions::handle_events()
{
	SDL_Event event;
    while(SDL_PollEvent(&event))
    {
        switch(event.type)
        {
        case SDL_QUIT:
			{
			CGamestate::set_next_state(STATE_EXIT);
            break;
			}
		case SDL_KEYDOWN:
			{
				switch(event.key.keysym.sym)
				{
					case SDLK_RETURN:
						{
							bool temp = fullscreen == 1 ? true : false;
							if(temp != SaveLoad->LoadFullscreen())						//Prfen, ob Fullscreen-Option gendert wurde
							{															//wenn ja, screen ndern
								if(fullscreen == true)
									screen = SDL_SetVideoMode(1920, 1080, 32, SDL_HWSURFACE | SDL_DOUBLEBUF |SDL_FULLSCREEN);
								else
									screen = SDL_SetVideoMode(1280, 720, 32, SDL_HWSURFACE | SDL_DOUBLEBUF );
							}

							SaveLoad->SaveDifficulty(difficulty);
							SaveLoad->SaveFullscreen(fullscreen == 1 ? true : false);

							CGamestate::set_next_state(STATE_MENU);
							break;
						}
					case SDLK_ESCAPE:
						{
							CGamestate::set_next_state(STATE_MENU);
							break;
						}
					case SDLK_DOWN:
						{
							
								curSelect++;

								if(curSelect == 3)
									curSelect=1;

							break;
						}
					case SDLK_UP:
						{
							curSelect--;

							if(curSelect == 0)
								curSelect=2;
							
							break;
						}
					case SDLK_RIGHT:
						{
							if(curSelect == 1)
							{
								difficulty ++;
								if(difficulty >= 4)
									difficulty = 3;
							}
							if(curSelect == 2)
							{
								fullscreen ++;
								if(fullscreen >= 3)
									fullscreen = 2;
							}
							break;
						}
					case SDLK_LEFT:
						{
							if(curSelect == 1)
							{
								difficulty --;
								if(difficulty <= 0)
									difficulty = 1;
							}
							if(curSelect == 2)
							{
								fullscreen --;
								if(fullscreen <= 0)
									fullscreen = 1;
							}
							break;
						}
				}			

			}
        }
    }
}


void COptions::logic()
{
}

void COptions::render(SDL_Surface * screen)
{	

	if(!this->screen)
		this->screen = screen;
	
	Background->Render(screen);

	Difficulty->Render(screen, difficulty-1);						
	Fullscreen->Render(screen, fullscreen-1);		


	if(curSelect == 1)
		Select1->Render(screen);
	else
		Select2->Render(screen);
}
