#include "SaveLoad.h"
#include <fstream>

using namespace std;

CSaveLoad::CSaveLoad()
{
	ifstream test("Settings.pong");						//Prfen, ob Datei schon existiert, sonst Datei mit Standartwerten erstellen
	if(!test)
	{
		State.difficulty = 2;		//auf Standartwert(medium) stellen
		State.fullscreen = 0;       //auf Standartwert(fenstermodus) stellen

		SaveState();
	}
	else
	{
		LoadState();				//Wenn Datei existiert, dann Laden
	}

	test.close();
}


int CSaveLoad::LoadDifficulty()
{
	LoadState();

	return (State.difficulty);
}

//Gibt Fullscreen einstellung zurck
bool CSaveLoad::LoadFullscreen()
{
	LoadState();

	return (State.fullscreen);
}


//Speichert Schwierigkeitseinstellung
void CSaveLoad::SaveDifficulty (int newDifficulty)
{
	LoadState();

	if(newDifficulty != State.difficulty)
	{
		State.difficulty = newDifficulty;

		SaveState();
	}
}

//Speichert Fullscreeneinstellung
void CSaveLoad::SaveFullscreen(bool newFullscreen)
{
	LoadState();

	if(newFullscreen != State.fullscreen)
	{
		State.fullscreen = newFullscreen;

		SaveState();
	}
}



//Aus Settings.pong laden
void CSaveLoad::LoadState()
{
	fstream stream;
		stream.open("Settings.pong",ios::binary | ios::in);

		stream.read((char *) &State, sizeof(State));
		stream.close();
}

//Speichern
void CSaveLoad::SaveState()
{
	fstream stream;
		stream.open("Settings.pong",ios::binary | ios::out);
		
		stream.write((char *) &State, sizeof(State));
		stream.close();
}

