/*
Vorlage Aus: C++ fr Spieleprogrammierer
copyright by Heiko Kalista
*/

#ifndef SPRITE_HPP
#define SPRITE_HPP

#include<SDL.h>
#include<string>
#include"SaveLoad.h"

using namespace std;

class CSprite
{
  public:
    CSprite ();
    ~CSprite ();

    void Load        (const string sFilename, const string sFilenameSca);
    void Load        (const string sFilename, const string sFilenameSca, int NumFrames,
                      int FrameWidth, int FrameHeight);
    void SetColorKey (int R, int G, int B);
    void SetPos      (float fXPos, float fYPos);
    void Render      (SDL_Surface * screen);
    void Render      (SDL_Surface * screen, float fFrameNumber);
    SDL_Rect GetRect () {return m_Rect;}

  private:
    SDL_Surface *m_pScreen; // Zeiger auf den Screen des Frameworks
    SDL_Surface *m_pImage;  // Das eigentliche Bild des Sprites
    SDL_Rect m_Rect;        // Rect des Sprites
    SDL_Rect m_FrameRect;   // Ausschnitt fr Animationsphase
    int m_NumFrames;        // Anzahl der Animationsphasen
    int m_FrameWidth;       // Breite einer Animationsphase
    int m_FrameHeight;      // Hhe einer Animationsphase
    int m_NumFramesX;       // Wie viele Anim-Phasen in X-Richtung?

	CSaveLoad * SaveLoad;
	bool fullscreen;
	SDL_Rect scaFrameRect;
	SDL_Rect scaRect;

};

#endif
